Index: trunk/kernel/syscalls/sys_chdir.c
===================================================================
--- trunk/kernel/syscalls/sys_chdir.c	(revision 11)
+++ trunk/kernel/syscalls/sys_chdir.c	(revision 23)
@@ -1,15 +1,16 @@
 /*
- * sys_chdir: change process current work directory
+ * sys_chdir: change process current working directory
  * 
- * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Author    Alain Greiner (2016,2017)
+ *
  * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-kernel.
+ * This file is part of ALMOS-MKH.
  *
- * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -17,45 +18,78 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <cpu.h>
+#include <hal_types.h>
+#include <hal_uspace.h>
 #include <chdev.h>
-#include <driver.h>
 #include <rwlock.h>
 #include <vfs.h>
-#include <sys-vfs.h>
+#include <errno.h>
 #include <thread.h>
-#include <ku_transfert.h>
-#include <task.h>
+#include <printk.h>
+#include <process.h>
 
-int sys_chdir (char *pathname)
+/////////////////////////////////
+int sys_chdir ( char * pathname )
 {
-	register error_t err = 0;
-	register struct thread_s *this;
-	register struct task_s *task;
-	struct ku_obj ku_path;
+	error_t   error;
+    paddr_t   paddr;
+    uint32_t  length;
+    char      kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
 
-	this = current_thread;
-	task = current_task;
+	thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
 
-	if(!pathname)
+    // check pathname in user space
+    error = vmm_v2p_translate( false , pathname , &paddr );
+
+	if( error )
 	{
-		this->info.errno = EINVAL;
+        printk("\n[ERROR] in %s : user buffer unmapped  for thread %x in process %x\n",
+               __FUNCTION__ , this->trdid , process->pid );
+		this->errno = EINVAL;
 		return -1;
 	}	
       
-	KU_BUFF(ku_path, pathname);
-	rwlock_wrlock(&task->cwd_lock);
+    // get pathname length
+    length = hal_strlen_from_uspace( pathname );
+
+    if( length >= CONFIG_VFS_MAX_PATH_LENGTH )
+    {
+        printk("\n[ERROR] in %s : pathname too long for thread %x in process %x\n",
+               __FUNCTION__ , this->trdid , process->pid );
+		this->errno = ENFILE;
+        return -1;
+    }
+ 
+	// get pathname copy in kernel space
+    hal_copy_from_uspace( kbuf, pathname, length );
+
+    // get cluster and local pointer on reference process
+    xptr_t      ref_xp  = process->ref_xp;
+    process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
+    cxy_t       ref_cxy = GET_CXY( ref_xp );
+
+    // get extended pointer on cwd lock in reference process
+    xptr_t lock_xp = hal_remote_lwd( XPTR( ref_cxy , &ref_ptr->cwd_lock ) );
 	
-	if((err = vfs_chdir(&ku_path, &task->vfs_cwd)))
+    // get cwd lock in read mode 
+	remote_rwlock_rd_lock( lock_xp );
+
+    // call relevant VFS function
+	error = vfs_chdir( process->vfs_cwd_xp , kbuf );
+
+    // release cwd lock 
+	remote_rwlock_rd_unlock( lock_xp );
+
+	if( error )
 	{
-		rwlock_unlock(&task->cwd_lock);
-		this->info.errno = (err < 0) ? -err : err;
+        printk("\n[ERROR] in %s : cannot change current directory\n", __FUNCTION__ );
+		this->errno = error;
 		return -1;
 	}
    
-	rwlock_unlock(&task->cwd_lock);
 	return 0;
 }
